#include <ansi_c.h>
#include <formatio.h>
#include <NIDAQmx.h>
#include <cvirte.h>		
#include <userint.h>
#include "daqtest.h"
static int fileStatus;
static int panelsel;
static TaskHandle taskHandle;

static int paneldaq;

char fileName[MAX_PATHNAME_LEN];

char imeTaska [6][64];

int main (int argc, char *argv[])
   {
   if (InitCVIRTE (0, argv, 0) == 0)
      return -1;	/* out of memory */
	
   if ((paneldaq = LoadPanel (0, "daqtest.uir", PANELDAQ)) < 0)//ucitavanje panela PANELDAQ u memoriju, i dodeljivanje pokazivaca paneldaq
      return -1;
	
   DisplayPanel (paneldaq);//prikaz panela na ekranu
	
   	
   //DAQmxLoadTask ("napon0", &taskHandle);
	
	
   RunUserInterface ();//glavna petlja
	
	
   // ukoliko je FileStatus !=0 postoji aktivan task koji treba iskljuciti
   if (fileStatus) DAQmxClearTask (taskHandle);
	
	
   DiscardPanel (paneldaq);	 //brisanje panela sa ekrana i iz memorije
	
   return 0;
   }


int CVICALLBACK Quit (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
	     QuitUserInterface (0);//izlazak iz glavne petlje
		 break;
		 
	  case EVENT_LEFT_DOUBLE_CLICK:
		 break;
	  }
   return 0;
   }

int CVICALLBACK Tick (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   int enable;
   float64 sample;
   double maximum, minimum;
	
   switch (event)
      {
	  case EVENT_TIMER_TICK:
		 DAQmxReadAnalogScalarF64 (taskHandle, 10.0, &sample, 0);//citanje taska u promenljivu sample
		 SetCtrlVal (paneldaq, PANELDAQ_THERM, sample);//prikaz odbirka na termometru
		 PlotStripChartPoint (paneldaq, PANELDAQ_STRIPCHART, sample);//prikaz odbirka na stripchartu
			 
		 GetCtrlVal(paneldaq,PANELDAQ_MAXIMUM,&maximum);//ocitavanje vrednosti gornjeg praga
		 
		 if (sample > maximum) SetCtrlVal (paneldaq, PANELDAQ_ALARMHI, 1)  ;//ako je odbirak veci od gornjeg praga ukljucuje se dioda
		 else SetCtrlVal (paneldaq, PANELDAQ_ALARMHI, 0) ;//ako je manji dioda se gasi
			 
			
         GetCtrlVal(paneldaq,PANELDAQ_MINIMUM,&minimum);//ocitavanje vrednosti donjeg praga
         		 
		 if (sample < minimum) SetCtrlVal (paneldaq, PANELDAQ_ALARMLO, 1)  ;//ako je odbirak manji od donjeg praga ukljucuje se dioda
		 else SetCtrlVal (paneldaq, PANELDAQ_ALARMLO, 0) ;//ako je veci dioda se gasi
			 
			 
		 GetCtrlVal (paneldaq, PANELDAQ_ENABLE, &enable);//ocitavanje vrednosti kontrole za dozvolu upisa u fajl
		 if (enable)  //enable !=0
		    {
			//GetCtrlVal (paneldaq, PANELDAQ_FILENAME, fileName);
			ArrayToFile (fileName, &sample, VAL_DOUBLE, 1, 1, VAL_GROUPS_TOGETHER, VAL_GROUPS_AS_COLUMNS, VAL_CONST_WIDTH, 10,
							 VAL_ASCII, VAL_APPEND);
			//snimanje odbirka u fajl koji je izabran u drugom prozoru	
			}
		 break;
	  }
   return 0;
   }


int CVICALLBACK Power (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   unsigned char power;
   switch (event)
      {
	  case EVENT_COMMIT:
		 GetCtrlVal (paneldaq, PANELDAQ_POWER, &power);//ocitavanje preklopnika POWER
		 if (power == 1)//if (power) //ako je u stanju UKLJ
			{
			unsigned char samplerate;
			
			//deaktivacija kontrola
			SetCtrlAttribute (paneldaq, PANELDAQ_CLEAR, ATTR_DIMMED, 1);
			SetCtrlAttribute (paneldaq, PANELDAQ_SAMPLERATE, ATTR_DIMMED, 1);
			SetCtrlAttribute (paneldaq, PANELDAQ_FILENAME, ATTR_DIMMED, 1);  
			SetCtrlAttribute (paneldaq, PANELDAQ_SELECT, ATTR_DIMMED, 1);  
			
			
			GetCtrlVal (paneldaq, PANELDAQ_SAMPLERATE, &samplerate);//ocitavanje kontrole za brzinu tajmera
			SetCtrlAttribute (paneldaq, PANELDAQ_TIMER, ATTR_INTERVAL, samplerate*0.01);//podesavanje brzine tajmera
				
				
			SetCtrlAttribute (paneldaq, PANELDAQ_TIMER, ATTR_ENABLED, 1);//ukljucivanje tajmera
		    }
		 else
			{	
			SetCtrlAttribute (paneldaq, PANELDAQ_TIMER, ATTR_ENABLED, 0);//iskljucivanje tajmera
			
			//aktivacija kontrola
			SetCtrlAttribute (paneldaq, PANELDAQ_CLEAR, ATTR_DIMMED, 0);
			SetCtrlAttribute (paneldaq, PANELDAQ_SAMPLERATE, ATTR_DIMMED, 0);  
			SetCtrlAttribute (paneldaq, PANELDAQ_FILENAME, ATTR_DIMMED, 0);  	
			SetCtrlAttribute (paneldaq, PANELDAQ_SELECT, ATTR_DIMMED, 0);  
			}
		 break;
	  
	  case EVENT_VAL_CHANGED:
		 break;
	  
	  case EVENT_LEFT_DOUBLE_CLICK:
		 break;
      }
   return 0;
   }

int CVICALLBACK Clear (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
		 ClearStripChart (paneldaq, PANELDAQ_STRIPCHART);//brisanje stripcharta
		 break;
	  
	  case EVENT_LEFT_DOUBLE_CLICK:
		 break;
	  }
   return 0;
   }

int CVICALLBACK MaxCheck (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   double minimum, maximum;
   
   switch (event)
      {
	  case EVENT_COMMIT:
		 GetCtrlVal (paneldaq, PANELDAQ_MINIMUM, &minimum);//ocitavanje donjeg praga
		 GetCtrlVal (paneldaq, PANELDAQ_MAXIMUM, &maximum);//ocitavanje gornjeg praga
		 if (minimum > maximum) //ukoliko je besmislena kombonacija, vracanje gornjeg praga na granicnu dozvoljenu vrednost
		    SetCtrlVal(paneldaq, PANELDAQ_MAXIMUM,minimum);
		 	
		 break;
	  
	  case EVENT_VAL_CHANGED:
		 break;
	  
	  case EVENT_LEFT_DOUBLE_CLICK:
		 break;
	  }
   return 0;
   }


int CVICALLBACK MinCheck (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   double minimum, maximum;
	
   switch (event)
      {
	  case EVENT_COMMIT:
         GetCtrlVal (paneldaq, PANELDAQ_MINIMUM, &minimum);
		 GetCtrlVal (paneldaq, PANELDAQ_MAXIMUM, &maximum);
		 if (minimum > maximum) //ukoliko je besmislena kombonacija, vracanje donjeg praga na granicnu dozvoljenu vrednost
		    SetCtrlVal(paneldaq, PANELDAQ_MINIMUM,maximum);			
			
		 break;
	  case EVENT_VAL_CHANGED:
		 break;
	  
	  case EVENT_LEFT_DOUBLE_CLICK:
		 break;
	  }
   return 0;
   }


int CVICALLBACK Select (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   char *parce;
   char taskovi[256];
   char brojTaskova;
   char i;
   	
   switch (event)
      {
	  case EVENT_COMMIT:
	     {
		 if (fileStatus) //ako postoji ukljucen task
			{
			DAQmxClearTask(taskHandle);//iskljucivanje taska	 
			 
			//preostale linije mogu se izvrsavati i van IF-a
			fileStatus=0;
			 
			//brisanje teksta u glavnom prozoru
			SetCtrlVal (paneldaq, PANELDAQ_FILENAME, "");
			SetCtrlAttribute (paneldaq, PANELDAQ_STRIPCHART, ATTR_LABEL_TEXT, "");
			SetCtrlAttribute (paneldaq, PANELDAQ_THERM, ATTR_LABEL_TEXT, "");
			 
			//deaktivacija kontrola
			SetCtrlAttribute (paneldaq, PANELDAQ_MINIMUM, ATTR_DIMMED, 1);			
			SetCtrlAttribute (paneldaq, PANELDAQ_MAXIMUM, ATTR_DIMMED, 1);
			SetCtrlAttribute (paneldaq, PANELDAQ_ENABLE, ATTR_DIMMED, 1);
			SetCtrlAttribute (paneldaq, PANELDAQ_SAMPLERATE, ATTR_DIMMED, 1);
			SetCtrlAttribute (paneldaq, PANELDAQ_CLEAR, ATTR_DIMMED, 1);
			SetCtrlAttribute (paneldaq, PANELDAQ_POWER, ATTR_DIMMED, 1);
			}
		 DAQmxGetSystemInfoAttribute (DAQmx_Sys_Tasks, taskovi, 256);//dobijanje spisak taskova u jednom stringu
		  //"napon0, napon1, napon2,...
 		  //MessagePopup ("INFO", taskovi);//ispis odziva, za debag
		  
		 parce = strtok (taskovi, ", ");//funkcijom strtok se iz odziva "seckaju" imena pojedinih taskova
		 brojTaskova = 0;//postavljanje brojaca taskova na nulu
			
		 while (parce!=NULL)//dokle god ima nesto "iseckano"
			{
			strcpy (imeTaska[brojTaskova], parce);//kopiranje "iseckamog" stringa u niz imena taskova
			brojTaskova++;//azuriranje broja taskova
			//MessagePopup ("INFO", parce);//ispis imena taska, za debag
			parce = strtok (NULL, ", ");//seckamo dalje
			}
		 
		 panelsel = LoadPanel (paneldaq, "daqtest.uir", PANELSEL);//ucitavanje drugog panela u memoriju
		 InstallPopup (panelsel);//prikaz na ekranu drugog panela
			
         //punjenje liste imenima taskova			
		 for (i= 0; i<brojTaskova; i++)
			{
			InsertListItem (panelsel, PANELSEL_LISTA, i, imeTaska[i], i);
		    } 
		 	
		 break;
	     }
	  
	  case EVENT_LEFT_DOUBLE_CLICK:
		 break;
	  }
   return 0;
   }

int CVICALLBACK Back (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
		 if (fileStatus)//samo ukoliko je izabran fajl ide se dalje u otvaranje taska
			{
			int index;
			GetCtrlVal (panelsel, PANELSEL_LISTA, &index);//ucitavanje rednog broja taska
			SetCtrlVal (paneldaq, PANELDAQ_FILENAME, fileName);//upis putanje do fajla u glavnom prozoru
			
			DAQmxLoadTask (imeTaska[index], &taskHandle);//ucitavanje taska
			
			//upisivanje imena taska iznad stripcharta i thermometra u glavnom prozoru
			SetCtrlAttribute (paneldaq, PANELDAQ_STRIPCHART, ATTR_LABEL_TEXT, imeTaska[index]);
			SetCtrlAttribute (paneldaq, PANELDAQ_THERM, ATTR_LABEL_TEXT, imeTaska[index]);

			//aktivacija kontrola
			SetCtrlAttribute (paneldaq, PANELDAQ_MINIMUM, ATTR_DIMMED, 0);			
			SetCtrlAttribute (paneldaq, PANELDAQ_MAXIMUM, ATTR_DIMMED, 0);
			SetCtrlAttribute (paneldaq, PANELDAQ_ENABLE, ATTR_DIMMED, 0);
			SetCtrlAttribute (paneldaq, PANELDAQ_SAMPLERATE, ATTR_DIMMED, 0);
			SetCtrlAttribute (paneldaq, PANELDAQ_CLEAR, ATTR_DIMMED, 0);
			SetCtrlAttribute (paneldaq, PANELDAQ_POWER, ATTR_DIMMED, 0);
			}
		 else 
			{
			MessagePopup("GRESKA","Nije izabrana datoteka!!!");//poruka o gresci ako nije izabran fajl
			}
		 DiscardPanel (panelsel);//brisanje malog prozora sa ekrana i iz memorije
		 break;
	  
	  case EVENT_LEFT_DOUBLE_CLICK:
		 break;
	  }
   return 0;
   }

int CVICALLBACK FileSection (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
		 break;
	  
	  case EVENT_VAL_CHANGED:
	     break;
		
	  case EVENT_LEFT_DOUBLE_CLICK:
		 //izbor fajla
		 fileStatus = FileSelectPopup ("", "*.cvi", "*.cvi;*.cvx", "IZBOR DATOTEKE", VAL_OK_BUTTON, 1, 0, 1, 1, fileName);
		 
		 if (fileStatus) //ako je izabran fajl upis putanje u prozoru
		    SetCtrlVal (panelsel, PANELSEL_FILENAME, fileName);
		 break;
	  }
   return 0;
   }
